module.exports = function(grunt) {

	// 1. All configuration goes here
	grunt.initConfig({
		pkg: grunt.file.readJSON('package.json'),

		sass: {
			dist: {
				options: {
					// Can be nested, compact, compressed, expanded
					style: 'expanded',
					lineNumbers: true
				},
				files: {
					'css/main.css': 'css/main.scss'
				}
			}
		},		
		postcss: {
		    options: {
		      
		      map: {
		          inline: false, // save all sourcemaps as separate files...
		          annotation: 'css/' // ...to the specified directory
		      },

		      processors: [
		        require('pixrem')(), // add fallbacks for rem units
		        require('autoprefixer')({browsers: 'last 2 versions'}), // add vendor prefixes
		        require('cssnano')() // minify the result
		      ]
		    },
		    dist: {
		      src: 'css/*.css'
		    }
		},
		watch: {
			scss: {
				files: [
				 	'css/*.scss',
					'css/**/*.scss',
					'css/**/**/*.scss',
					'css/**/**/**/*.scss'],
				tasks: ['sass'],
				options: {
					spawn: false,
				}
			},
			postcss: {
				files: ['css/*.css'],
				tasks: ['postcss'],
				options: {
					livereload: true,
					spawn: false,
				}
			}
		}
	});

	// 3. Where we tell Grunt we plan to use this plug-in.
	grunt.loadNpmTasks('grunt-contrib-watch');      // watch files for changes
	grunt.loadNpmTasks('grunt-contrib-sass');       // Gettin Sassy!
	grunt.loadNpmTasks('grunt-postcss');
	// 4. Where we tell Grunt what to do when we type "grunt" into the terminal.
	grunt.registerTask('default', ['watch']);

};
