define(['./module', 'jquery'], function (controllers, jQuery) {
    'use strict';
    
    controllers.controller("LandingController", ["$scope", "$state", "settings", "safaricom", "DTOptionsBuilder", "DTColumnDefBuilder", function($scope, $state,settings, safaricom, DTOptionsBuilder, DTColumnDefBuilder) {
	    	 
          	
            $scope.scores = safaricom.orderedScores();  

		    var getScores = function(){

		        var defer = $q.defer();

		        $scope.scores.$loaded().then(function(data) {
		            $scope.scores = data;
		            defer.resolve(data);
		        });

		        return defer.promise;
		    };   

		    $scope.dtInstance = {}; 

		    $scope.dtOptions = DTOptionsBuilder.fromFnPromise(function() {
		        return getScores();
		    }).withPaginationType('full_numbers')
		      .withDisplayLength(10)      
		      .withOption('language', {
		        zeroRecords: 'Loading Data... - OR No Internet Connection'
		      });
	    


		    $scope.dtColumnDefs = [
		        
		        DTColumnDefBuilder.newColumnDef(0),
		        DTColumnDefBuilder.newColumnDef(1), 
		        DTColumnDefBuilder.newColumnDef(2),
		        DTColumnDefBuilder.newColumnDef(3)
		    ]; 
    


	     
	  }

	]);
});
