define(['./module'], function (services) {

  services.factory('safaricom', ["$firebaseAuth", "$firebaseArray", "$firebaseObject", "$firebaseUtils", "$rootScope", "$stateParams", "$q", function($firebaseAuth, $firebaseArray, $firebaseObject, $firebaseUtils, $rootScope, $stateParams, $q) {
          
          var config = {
            apiKey: "AIzaSyA8o0CYglGaWowSCN_Tw8VVrFtoStZkD0s",
            authDomain: "sdgs-dev.firebaseapp.com",
            databaseURL: "https://sdgs-dev.firebaseio.com",
            storageBucket: "sdgs-dev.appspot.com"
          };

          firebase.initializeApp(config);

          var safaricomRef = firebase.database().ref();          

          var connectedRef = firebase.database().ref(".info/connected");          
          
          var staff_list = $firebaseArray(safaricomRef.child('staff'));
          var users_list = $firebaseArray(safaricomRef.child('users'));
          var scores_list = $firebaseArray(safaricomRef.child('scores'));
          
          var status = false;
                  
          var Safaricom = {

              auth: function(){
                return $firebaseAuth();
                //return firebase.auth()
              },

              login: function(){

                var deferred = $q.defer();

                var Auth = this.auth();               

                var fUser = Auth.$getAuth();

                //If there is a user logged in return
                if(fUser){

                  deferred.resolve(fUser);

                }else{ //Else login

                  Auth.$signInWithEmailAndPassword("izoneafrica@gmail.com", "izoneafrica").then(function(firebaseUser) {
                    deferred.resolve(firebaseUser);                    
                  }).catch(function(error) {
                    console.error("Authentication failed:", error);
                    deferred.resolve(false);
                  });

                }

                return deferred.promise;                

              },

              isConnected: function(){                          
                return status;
              }, 

              setConnected: function(value){                          
                status = value;
              },


              
              
              //STAFF

              allStaff: function () {
                return staff_list;
              },             


              createStaff: function (staff) {

                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var staff_copy = $firebaseUtils.toJSON(staff);

                    staff_list.$add(staff_copy).then(function(ref) {
                        Auth.$signOut();  //Logout after saving data                      
                        deferred.resolve(ref.key);
                    },function(error) {                        
                        console.log(error);
                        deferred.resolve(false);
                    });
                  }

                },function(error) {                                  
                    console.log(error);
                    deferred.resolve(false);
                });

                return deferred.promise;                

              },

              getStaff: function (staffId) {

                  return $firebaseObject(safaricomRef.child('staff').child(staffId));                
              },

              updateStaff: function (staffId, staff) {
                
                var onComplete = function(error) {
                  if (error) {
                    console.log('Updating staff failed');
                  } else {
                    console.log('Updating staff succeeded');
                  }
                };

                var staff_copy = $firebaseUtils.toJSON(staff);

                return safaricomRef.child('staff').child(staffId).update(staff_copy,onComplete);
                
              },

              deleteStaff: function (staff) {              

                return staff_list.$remove(staff);

              },


              //SCORES

              allScores: function () {
                return scores_list;
              },
              
              orderedScores: function () {
                return $firebaseArray(safaricomRef.child('scores').orderByPriority());
              },

              allStaffScores: function (staffId) {

                return $firebaseArray(safaricomRef.child('scores').orderByChild("staff_id").equalTo(staffId));
                
              },

              createScore: function (score) {
                
                var Auth = this.auth();               

                var deferred = $q.defer();
                                
                var promise = this.login(); //Check if am logged in before I save data to firebase

                promise.then(function(data) {

                  if(data != false){

                    var score_copy = $firebaseUtils.toJSON(score);
                    score_copy['.priority'] = -score_copy.points;

                    scores_list.$add(score_copy).then(function(ref) {
                        Auth.$signOut();  //Logout after saving data                      
                        deferred.resolve(ref.key);
                    },function(error) {                        
                        console.log(error);
                        deferred.resolve(false);
                    });
                  }

                },function(error) {                                  
                    console.log(error);
                    deferred.resolve(false);
                });

                return deferred.promise;


              },

              getScore: function (scoreId) {

                  return $firebaseObject(safaricomRef.child('scores').child(scoreId));                
              },

              updateScore: function (scoreId, score) {
                
                var onComplete = function(error) {
                  if (error) {
                    console.log('Updating score failed');
                  } else {
                    console.log('Updating score succeeded');
                  }
                };

                var score_copy = $firebaseUtils.toJSON(score);              

                return safaricomRef.child('scores').child(scoreId).update(score_copy,onComplete);
                
              },

              deleteScore: function (score) {

                return scores_list.$remove(score);

              },


              //USERS

              allUsers: function () {
                return users_list;
              },

              createUser: function (user) {  

                var onComplete = function(error) {
                  if (error) {
                    console.log('Adding user failed');
                  } else {
                    console.log('Adding user succeeded');
                  }
                };                         

                var user_copy = $firebaseUtils.toJSON(user);                                
                    
                var ref = safaricomRef.child('users').push(user_copy, onComplete);
                
                return ref.key();         

              },

              getUser: function (userId) {

                  return $firebaseObject(safaricomRef.child('users').child(userId));                
              },

              updateUser: function (userId, user) {
                
                var onComplete = function(error) {
                  if (error) {
                    console.log('Updating user failed');
                  } else {
                    console.log('Updating user succeeded');
                  }
                };

                var user_copy = $firebaseUtils.toJSON(user);              

                return safaricomRef.child('users').child(userId).update(user_copy,onComplete);
                
              },

              deleteUser: function (user) {

                return users_list.$remove(user);

              }, 

                        
              
              
          };
          
          

          connectedRef.on("value", function(snap) {

            if (snap.val() === true) {                 
                Safaricom.setConnected(true);
            }else {                
                Safaricom.setConnected(false);            
            }

          });

          return Safaricom;
     

  }]);


});


