/** define all the application routes 
 **/
define(['./app'], function(app) {
    'use strict';
    return app.config(["$stateProvider", "$urlRouterProvider", "$ocLazyLoadProvider", "IdleProvider", "KeepaliveProvider", "$sceDelegateProvider",  function($stateProvider, $urlRouterProvider, $ocLazyLoadProvider, IdleProvider, KeepaliveProvider, $sceDelegateProvider) {
        
        IdleProvider.idle(180); // in seconds
        IdleProvider.timeout(10); // in seconds
        KeepaliveProvider.interval(2); // in seconds


        $sceDelegateProvider.resourceUrlWhitelist([
            // Allow same origin resource loads.
            'self',
            // Allow loading from 192.168.1.* domain. 
            'http://192.168.1.*/**',

            // Allow loading from 192.168.0.* domain. 
            'http://192.168.0.*/**',

            // Allow loading from localhost domain. 
            'http://localhost/**'
        ]);
        
        
        $urlRouterProvider.otherwise('/landing');       
             
        //Home route 
        $stateProvider.state("landing", {
            url: "/landing",
            templateUrl: 'partials/landing.html',            
            controller:'LandingController',
            resolve: {                
                deps: ['$ocLazyLoad', function($ocLazyLoad) {
                    return $ocLazyLoad.load({
                        name: 'Recruit',
                        insertBefore: '#ng_load_plugins_before', // load the above css files before a LINK element with this ID. Dynamic CSS files must be loaded between core and theme css files
                        files: [                            
                            "vendor/plugins/bootstrap/js/bootstrap.min",
                            "vendor/plugins/js.cookie.min",
                            "vendor/plugins/bootstrap-hover-dropdown/bootstrap-hover-dropdown.min",
                            "vendor/plugins/jquery-slimscroll/jquery.slimscroll.min",
                            "vendor/plugins/jquery.blockui.min",
                            "vendor/plugins/uniform/jquery.uniform.min"
                        ] 
                    });
                }]
            }
        }); 


    }])
});